interface jlink
transport select swd

proc stm_flash {IMGFILE} {
	init
	reset init
	adapter_khz 3000
	halt
	# sleep 100
	# stm32l_enable_HSI
	sleep 100
	flash write_image erase unlock $IMGFILE 0 elf
	sleep 100 
	verify_image $IMGFILE
	sleep 100
	reset run
}

proc stm_erase {} {
	init
	reset init
	halt
	sleep 100
	stm32f1x mass_erase 0
	sleep 100
}

proc stm32l_enable_HSI {} {
    # Enable HSI as clock source
    echo "STM32L: Enabling HSI"

    # Set HSION in RCC_CR
    mww 0x40021000 0x00000a01

    # Set HSI as SYSCLK
    mww 0x40021004 0x00000000

    # Increase JTAG speed
    adapter_khz 2000
}

source [find target/stm32f1x.cfg]
puts "File name: $env(STM32_UPLOAD)"
stm_flash $env(STM32_UPLOAD)
shutdown